"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactNative = require("react-native");
const LINKING_ERROR = `The package 'react-native-printer-sunmi' doesn't seem to be linked. Make sure: \n\n` + _reactNative.Platform.select({
  ios: "- You have run 'pod install'\n",
  default: ''
}) + '- You rebuilt the app after installing the package\n' + '- You are not using Expo Go\n';
const PrinterSunmi = _reactNative.NativeModules.PrinterSunmi ? _reactNative.NativeModules.PrinterSunmi : new Proxy({}, {
  get() {
    throw new Error(LINKING_ERROR);
  }
});
const PrinterAPIs = {
  connect: PrinterSunmi.connect,
  disconnect: PrinterSunmi.disconnect,
  getInfo: PrinterSunmi.getInfo,
  DEVICES_NAME: PrinterSunmi.DEVICES_NAME,
  initLine: function () {
    let option = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    PrinterSunmi.initLine(option);
  },
  addText(text) {
    let option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    PrinterSunmi.addText(text, option);
  },
  printText(text) {
    let option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    PrinterSunmi.printText(text, option);
  },
  printTexts: PrinterSunmi.printTexts,
  printBarCode(code) {
    let option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    PrinterSunmi.printBarCode(code, option);
  },
  printQrCode(code) {
    let option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    PrinterSunmi.printQrCode(code, option);
  },
  printBitmap(uri) {
    let option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    const path = _reactNative.Image.resolveAssetSource(uri);
    PrinterSunmi.printBitmap({
      ...option,
      url: (path === null || path === void 0 ? void 0 : path.uri) || uri
    });
  },
  printDividingLine: PrinterSunmi.printDividingLine,
  autoOut: PrinterSunmi.autoOut,
  enableTransMode: PrinterSunmi.enableTransMode,
  printTrans: PrinterSunmi.printTrans,
  initCanvas: PrinterSunmi.initCanvas,
  renderText(text) {
    let option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    PrinterSunmi.renderText(text, option);
  },
  renderBarCode(code) {
    let option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    PrinterSunmi.renderBarCode(code, option);
  },
  renderQrCode(text) {
    let option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    PrinterSunmi.renderQrCode(text, option);
  },
  renderBitmap(uri, option) {
    const path = _reactNative.Image.resolveAssetSource(uri);
    PrinterSunmi.renderBitmap({
      ...option,
      url: (path === null || path === void 0 ? void 0 : path.uri) || uri
    });
  },
  renderArea() {
    let option = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    PrinterSunmi.renderArea(option);
  },
  printCanvas: PrinterSunmi.printCanvas,
  printFile: PrinterSunmi.printFile,
  sendEscCommand: PrinterSunmi.sendEscCommand,
  sendTsplCommand: PrinterSunmi.sendTsplCommand,
  openCashDrawer: PrinterSunmi.openCashDrawer,
  isCashDrawerOpen: PrinterSunmi.isCashDrawerOpen,
  lcdConfig: PrinterSunmi.lcdConfig,
  lcdShowText: PrinterSunmi.lcdShowText,
  lcdShowTexts: PrinterSunmi.lcdShowTexts,
  lcdShowBitmap: uri => {
    const path = _reactNative.Image.resolveAssetSource(uri);
    PrinterSunmi.lcdShowBitmap(path);
  },
  lcdShowDigital: PrinterSunmi.lcdShowDigital,
  watchError(errorHandler) {
    const eventEmitter = new _reactNative.NativeEventEmitter(_reactNative.NativeModules.PrinterSunmi);
    const errorEvent = eventEmitter.addListener('PRINT_ERROR', payload => {
      errorHandler(payload);
    });
    return () => {
      errorEvent.remove();
    };
  }
};
var _default = PrinterAPIs;
exports.default = _default;
//# sourceMappingURL=index.js.map